<?


/*
	libprop -- library to simulate and measure radio signal propagation
	
	Copyright (C) 2007 Jeffrey Sharkey, jsharkey.org
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


// adjust hue of incoming image
// hue.php?image=marker.png&hue=0

// now updated to just change to target color needed
// hue.php?image=marker.png&r=0&g=128&b=255

$source = $_GET["image"];
//$hue = $_GET["hue"];
$r = $_GET["r"];
$g = $_GET["g"];
$b = $_GET["b"];

$hsvsource = rgbtohsv(array(255,119,107));
$hsvtarget = rgbtohsv(array($r,$g,$b));

$hue = $hsvtarget[0] - $hsvsource[0];

//echo $hue;

// open image using gd, and change hue of all pixels


$source = imagecreatefrompng($source);
$width = imagesx($source);
$height = imagesy($source);

$target = imagecreatetruecolor($width, $height);
imagealphablending($target, false);
imagesavealpha($target, true);

imagecopy($target, $source, 0, 0, 0, 0, $width, $height);

// plot source image onto target with new alpha information
for($x = 0; $x < $width; $x++) {
for($y = 0; $y < $height; $y++) {
	$color = imagecolorat($target, $x, $y);
	$a = ($color & 0x7F000000) >> 24;
	$r = ($color >> 16) & 0xFF;
	$g = ($color >> 8) & 0xFF;
	$b = $color & 0xFF;

	// convert, adjust hue, convert back
	$hsv = rgbtohsv(array($r,$g,$b));
	$hsv[0] += $hue;
	$rgb = hsvtorgb($hsv);
	list($r,$g,$b) = $rgb;

	$color = imagecolorallocatealpha($target, $r, $g, $b, $a);
	imagesetpixel($target, $x, $y, $color);
}
}


header('Content-Type: image/png');
imagepng($target);















//rgbtohsv(array(255,255,0));
//hsvtorgb(array(0.1666,1,1));







function rgbtohsv($rgb) {

list($r, $g, $b) = $rgb;

$r /= 255;
$g /= 255;
$b /= 255;

$min = min($r, $g, $b);
$max = max($r, $g, $b);
$delta = $max - $min;

$v = $max;

if($delta == 0) {
	$h = 0; $s = 0;
} else {
	$s = $delta / $max;

	$dr = ((($max - $r) / 6) + ($delta / 2)) / $delta;
	$dg = ((($max - $g) / 6) + ($delta / 2)) / $delta;
	$db = ((($max - $b) / 6) + ($delta / 2)) / $delta;

	if($r == $max)
		$h = $db - $dg;
	else if($g == $max)
		$h = (1/3) + $dr - $db;
	else if($b == $max)
		$h = (2/3) + $dg - $dr;

	if($h < 0) $h += 1;
	if($h > 1) $h -= 1;
}

//echo "h=$h, s=$s, v=$v";
return array($h,$s,$v);

}







function hsvtorgb($hsv) {

list($h, $s, $v) = $hsv;

if($s == 0) {
	$r = $v * 255;
	$g = $v * 255;
	$b = $v * 255;
} else {
	$h = $h * 6;
	if($h == 6) $h = 0;
	$i = floor($h);
	$v1 = $v * ( 1 - $s );
	$v2 = $v * ( 1 - $s * ( $h - $i ) );
	$v3 = $v * ( 1 - $s * ( 1 - ( $h - $i ) ) );

   if      ( $i == 0 ) { $r = $v; $g = $v3; $b = $v1; }
   else if ( $i == 1 ) { $r = $v2; $g = $v; $b = $v1; }
   else if ( $i == 2 ) { $r = $v1; $g = $v; $b = $v3; }
   else if ( $i == 3 ) { $r = $v1; $g = $v2; $b = $v; }
   else if ( $i == 4 ) { $r = $v3; $g = $v1; $b = $v; }
   else                { $r = $v; $g = $v1; $b = $v2; }

   $r = $r * 255;
   $g = $g * 255;
   $b = $b * 255;
}

//echo "r=$r, g=$g, b=$b";
return array($r,$g,$b);

}











?>